<?php
	include 'functions.php';
?>

	<?php 
		// create object of functions class
		$function = new functions;
		
		// create array variable to store data from database
		$data = array();
		
		if(isset($_GET['keyword'])) {	
			// check value of keyword variable
			$keyword = $function->sanitize($_GET['keyword']);
			$bind_keyword = "%".$keyword."%";
		} else {
			$keyword = "";
			$bind_keyword = $keyword;
		}
			
		if (empty($keyword)) {
			$sql_query = "SELECT id, name, email, status, imageName FROM tbl_users ORDER BY id DESC";
		} else {
			$sql_query = "SELECT id, name, email, status, imageName FROM tbl_users WHERE name LIKE ? ORDER BY id DESC";
		}
		
		
		$stmt = $connect->stmt_init();
		if ($stmt->prepare($sql_query)) {	
			// Bind your variables to replace the ?s
			if (!empty($keyword)) {
				$stmt->bind_param('s', $bind_keyword);
			}
			// Execute query
			$stmt->execute();
			// store result 
			$stmt->store_result();
			$stmt->bind_result( 
					$data['id'],
					$data['name'],
					$data['email'],
					$data['status'],
					$data['imageName']
					);
			// get total records
			$total_records = $stmt->num_rows;
		}
			
		// check page parameter
		if (isset($_GET['page'])) {
			$page = $_GET['page'];
		} else {
			$page = 1;
		}
						
		// number of data that will be display per page		
		$offset = 10;
						
		//lets calculate the LIMIT for SQL, and save it $from
		if ($page) {
			$from 	= ($page * $offset) - $offset;
		} else {
			//if nothing was given in page request, lets load the first page
			$from = 0;	
		}	
		
		if (empty($keyword)) {
			$sql_query = "SELECT id, name, email, status, imageName FROM tbl_users ORDER BY id DESC LIMIT ?, ?";
		} else {
			$sql_query = "SELECT id, name, email, status, imageName FROM tbl_users WHERE name LIKE ? ORDER BY id DESC LIMIT ?, ?";
		}
		
		$stmt_paging = $connect->stmt_init();
		if ($stmt_paging ->prepare($sql_query)) {
			// Bind your variables to replace the ?s
			if (empty($keyword)) {
				$stmt_paging ->bind_param('ss', $from, $offset);
			} else {
				$stmt_paging ->bind_param('sss', $bind_keyword, $from, $offset);
			}
			// Execute query
			$stmt_paging ->execute();
			// store result 
			$stmt_paging ->store_result();
			$stmt_paging->bind_result(
				$data['id'],
				$data['name'],
				$data['email'],
				$data['status'],
				$data['imageName']
			);
			// for paging purpose
			$total_records_paging = $total_records; 
		}

		// if no data on database show "No Reservation is Available"
		if ($total_records_paging == 0) {
	
	?>

    <section class="content">

        <ol class="breadcrumb breadcrumb-offset">
            <li><a href="dashboard.php">Dashboard</a></li>
            <li class="active">Registered Users</a></li>
        </ol>

       <div class="container-fluid" id="fade-in">

            <div class="row clearfix">
                <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
                    <div class="card corner-radius">
                        <div class="header">
                            <h2>REGISTERED USERS</h2>
                        </div>

                        <div class="body body-offset table-responsive">
	                        
	                        <form method="get" id="form_validation">
	                        	<table class='table'>
	                        		<tr>
	                        			<td>
	                        				<div class="form-group form-float">
												<div class="form-line">
													<input type="text" class="form-control" name="keyword" placeholder="Search user...">
												</div>
											</div>
										</td>
	                        			<td width="1%"><button type="submit" class="btn bg-blue btn-circle waves-effect waves-circle waves-float"><i class="material-icons">search</i></button></td>
	                        		</tr>
	                        	</table>
							</form>

							<div class="col-sm-10">Whoops, No data found!</div>

						</div>
                    </div>
                </div>
            </div>
        </div>
    </section>

	<?php 
		// otherwise, show data
		} else {
			$row_number = $from + 1;
	?>

    <section class="content">

        <ol class="breadcrumb breadcrumb-offset">
            <li><a href="dashboard.php">Dashboard</a></li>
            <li class="active">Registered Users</a></li>
        </ol>

       <div class="container-fluid">

            <div class="row clearfix">
                <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
                    <div class="card corner-radius">
                        <div class="header">
                            <h2>REGISTERED USERS</h2>
                        </div>

                        <div class="body body-offset table-responsive">
	                        
	                        <form method="get" id="form_validation">
	                        	<table class='table'>
	                        		<tr>
	                        			<td>
	                        				<div class="form-group form-float">
												<div class="form-line">
													<input type="text" class="form-control" name="keyword" placeholder="Search user...">
												</div>
											</div>
										</td>
	                        			<td width="1%"><button type="submit" class="btn bg-blue btn-circle waves-effect waves-circle waves-float"><i class="material-icons">search</i></button></td>
	                        		</tr>
	                        	</table>
							</form>
										
							<table class='table table-hover table-striped table-offset'>
								<thead>
									<tr>
										<th>Name</th>
										<th>Email</th>
										<th>Profile</th>
										<th>Status</th>
										<th>Action</th>
									</tr>
								</thead>

								<?php 
									while ($stmt_paging->fetch()) { ?>
										<tr>
											<td><?php echo $data['name'];?></td>
											<td><?php echo $data['email'];?></td>
											<td>
                                                <?php
                                                if ($data['imageName'] == NULL) {

                                                    ?>
                                                    <img src="assets/images/ic_user.png" class="rounded-image" height="36px" width="36px"/>
                                                    <?php

                                                } else {

                                                    ?>
                                                    <img src="upload/avatar/<?php echo $data['imageName'];?>" class="rounded-image" height="36px" width="36px"/>

                                                <?php } ?>
                                            </td>
											
											<td>
                                                <?php if ($data['status'] == 1) { ?>
                                                    <span class="label label-rounded bg-blue">ENABLED</span>
                                                 <?php } else { ?>
                                                    <span class="label label-rounded bg-red">DISABLED</span>
                                                <?php } ?>
                                            </td>

                                            <td>
                                                <a href="edit-user.php?id=<?php echo $data['id'];?>"><i class="material-icons">mode_edit</i></a>
                                            </td>

										</tr>
								<?php 
									}
								?>
							</table>

							<h4><?php $function->doPages($offset, 'registered-user.php', '', $total_records, $keyword); ?></h4>
							<?php 
								}
							?>
						</div>
                    </div>
                </div>
            </div>
        </div>
    </section>